package common.msg;

public class MsgUtil {
     /** 付加情報マーク */
    static private final String mark = "@@";
/*
    public String getMsg(Properties msgprop, String msgid, ArrayList<String> addmsgList) {

        //編集元メッセージテキストを取得
        String src = "";

        src = (String)msgprop.get(msgid);

        if (src == null) {
            //当該IDのメッセージが無い
            return src;
        }

        if (addmsgList == null) {
            return src;
        }
        if (addmsgList.size() == 0){
            return src;
        }
        StringBuffer sbf = new StringBuffer(src);

        for(int i=0; i < addmsgList.size() ; i++) {
            int idx = sbf.toString().indexOf(mark);

            if (idx == -1) {
                break; //マークが無いので終了
            }
            String addtxt = addmsgList.get(i) ;
            if (addtxt.length() == 0){
                addtxt = "[空文字]";
            }
            sbf = sbf.replace(idx, idx + mark.length(), addtxt);
        }
        String txt = sbf.toString();

//		// 末尾の"@@" は、取り除く
//		if (txt.endsWith(mark)){
//			txt.replace(mark,  "");
//		}

        return txt;
    }
    */
    /**
     * StackTrace編集
     * @param 例外オブジェクト
     * @return 編集結果
     */
    
    static public String editStackTrace(Exception e) {
        
        StringBuffer sbf = new StringBuffer(); 
        StackTraceElement[] ste = e.getStackTrace();
        String CRLF = System.lineSeparator();

        Throwable th = e.getCause();
        int lpcnt = ste.length;
        if (th==null) {
            //最後のメッセージは出力しない
            lpcnt = ste.length-1;
        }
        sbf.append(e.getClass().getCanonicalName()).append(": ").append(e.getMessage()).append(CRLF);
        for (int i = 0; i < lpcnt; i++) {
            sbf.append("    ").append("at ").append(ste[i].getClassName()).append(".").append(ste[i].getMethodName()).append("(").append(ste[i].getFileName()).
            append(":").append(ste[i].getLineNumber()).append(")").append(CRLF);

        }
        if (th!=null) {
            sbf.append("Caused by: ").append( e.getCause().getClass().getCanonicalName()).append(":").append(e.getCause().getMessage()).append(CRLF);
            StackTraceElement[] ste2 = e.getCause().getStackTrace();
            for (int j = 0; j < (ste2.length-1); j++) {
                sbf.append("    ").append("at ").append(ste2[j].getClassName()).append(".").append(ste2[j].getMethodName()).append("(").append(ste2[j].getFileName()).
                append(":").append(ste2[j].getLineNumber()).append(")").append(CRLF); 
            }
        }
        return sbf.toString();
    }

}
